#include "usart.h"

#define BAUD 115200UL

void usart_init()
{
    const uint16_t ubrr = ( ( ( F_CPU + 8 * BAUD ) / ( 16 * BAUD ) ) - 1 );

    /*Set baud rate */
    UBRR0H = ( uint8_t ) ( ubrr >> 8 );
    UBRR0L = ( uint8_t ) ( ubrr & 0xff );
    /* Enable receiver and transmitter */
    // TODO
    /* Set frame format: 8data, 1stop bit */
    // TODO
}

void usart_send( uint8_t data )
{
    /* Wait for empty transmit buffer */
    while ( !( UCSR0A & ( 1 << UDRE0 ) ) )
        ;
    /* Put data into buffer, sends the data */
    UDR0 = data;
}

uint8_t usart_recv()
{
    /* Wait for data to be received */
    while ( !( UCSR0A & ( 1 << RXC0 ) ) )
        ;
    /* Get and return received data from buffer */
    return UDR0;
}

void usart_puts( const char* string )
{
    while( *string )
    {
        usart_send( *string++ );
    }
}

void usart_gets( char* buf, unsigned int n )
{
    uint8_t c;
    uint8_t* ptr = ( uint8_t* ) buf;

    if( !n ) return;

    while( ( c = usart_recv() ) != '\r' ) {
       *ptr++ = c;
       n--;
       if( n == 1 )
           break;
    };

    *ptr = '\0';
}




